:userdoc.
:h1 res=8.Introduction
:i1 id=ix1.Introduction
:sl compact.
:li.
:li.
:font facename='Arial' size=12x8.:hp2.Introduction:ehp2.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.SblEdit is a text editor that runs under Presentation Manager environment and 
allows you to edit, compile, debug and run SBL modules&per.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.SblEdit behaves much like the OS/2 System Editor application&per.  This document 
assumes that you are familiar with the System Editor, and does not document the 
text editing capabilities&per.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.SblEdit includes a built-in Help function to provide a quick reference to the 
SBL language&per.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.SblEdit has buttons on its main window that can be selected in the standard way 
with the mouse or by holding down the Ctrl key and hitting the letter 
underlined on the button&per.  The Esc key can also be used to Stop program 
execution (in either run or debug mode)&per.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.SblEdit is a sample program which Softbridge has developed to test SBL&per.  While 
we attempt to make it solid and useful, it is not "product-quality"&per.  We do not 
include source for SblEdit as part of a SBL source license&per.  We include it as 
part of the SBL runtime for the convenience to our customers (and because we 
use it as the basis of our test suite)&per.:font facename=default size=0x0.
:li.
:li.
:li.
:font facename='Arial' size=12x8.:hp2.Edit Mode:ehp2.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.When editing a program, SBL behaves much like Notepad&per.  There are three buttons 
visible on the screen&colon.  :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.C:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.ompile, :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.R:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.un and :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.D:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.ebug&per.  See below for details on 
Compiling, Running, and Debugging programs&per.:font facename=default size=0x0.
:li.
:li.
:li.
:font facename='Arial' size=12x8.:hp2.Using the Help Facility:ehp2.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.You can access the help facility by either using the Help menu directly or by 
positioning the edit caret over a keyword and hitting the F1 key&per.  If the F1 
key is used, SblEdit will attempt to find the specified keyword within the SBL 
help document&per.  The SBL help document (including source and make file) is 
included as part of the SBL Runtime License&per.:font facename=default size=0x0.
:li.
:li.
:li.
:font facename='Arial' size=12x8.:hp2.Compiling a Program:ehp2.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.When in edit mode you can explicitly compile a SBL program, using either the 
button or menu pick&per.  If the current file has not been saved, it will 
automatically be saved before compiling&per.  The autosave feature can be cleared 
by removing the check on the Auto Save and Compile menu pick under Compiler 
Options&per.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.SblEdit will highlight lines containing warnings and errors&per.  Warnings can be 
ignored by clearing the check on the Report Warnings menu pick under Compiler 
Options&per.  If there are warnings or errors, two additional buttons (:font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.N:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.ext Error 
and :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.P:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.rev Error) will be displayed which allow you to step over the errors&per.:font facename=default size=0x0.
:li.
:li.
:li.
:font facename='Arial' size=12x8.:hp2.Running a Program:ehp2.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.When you ask SblEdit to run a module (through either a Run or Debug request) 
SblEdit will automatically compile the program if necessary&per.  Next, SblEdit 
will look for a :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp2.Sub Main:ehp2.:font facename=default size=0x0.:font facename='Arial' size=10x6.&per.  If there is no :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp2.Sub Main:ehp2.:font facename=default size=0x0.:font facename='Arial' size=10x6. in the module, SblEdit will 
report an error&per.  Note that this is not required by SBL itself; this is just 
the way SblEdit makes use of SBL&per.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.When running a program, SblEdit will display a single button&colon. Stop&per.  This 
button can be hit using the mouse, or you may use the Esc key&per.  If you hit this 
button, you will enter Debug mode&per.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.If a :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp2.Stop:ehp2.:font facename=default size=0x0.:font facename='Arial' size=10x6. statement is executed, an :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp2.Assert:ehp2.:font facename=default size=0x0.:font facename='Arial' size=10x6. statement fails, or an untrapped 
error occurs within the running program, the program will stop executing, and 
SblEdit will enter debug mode&per.:font facename=default size=0x0.
:li.
:li.
:li.
:font facename='Arial' size=12x8.:hp2.Debugging a Program:ehp2.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.When you are in debugging mode, the SblEdit button bar displays buttons for 
Step :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.I:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.nto, Step :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.O:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.ver, :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.C:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.ontinue, :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.B:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.reakpoint, :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.E:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.xit, :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.V:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.ars, :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.A:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.nimate, and Ca:font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.l:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.ls&per.  
The line of code which will execute next is displayed with foreground and 
background colors reversed (white on black)&per.  :font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.SblEdit provides a wide variety of debugging capabilities, all of which are 
implemented using the standard SBL API&per.  Two kinds of single step are included&colon. 
Step :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.I:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.nto, which steps into called procedures and Step :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.O:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.ver, which steps over 
called procedures&per.  The :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.C:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.ontinue button switches SblEdit back to running mode&per.  :font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.Breakpoints can be set on any executable line of code&per.  To set a breakpoint 
with the mouse double-click on the line; to clear the breakpoint, double-click 
the mouse again&per.  To set (or clear) a breakpoint with the keyboard, move the 
caret to the desired line and hit the Breakpoint button (Ctrl-B or use the 
mouse)&per.  Finally, the F9 key can set and clear breakpoints&per.  Breakpoints are 
indicated by a red highlight&per.  :font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.The :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.E:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.xit button halts execution of the program being edited and returns you to 
edit mode&per.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.The :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.V:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.ars button controls the display of the Variables window&per.  It acts as a 
toggle, causing the window to appear and disappear&per.  SblEdit allows you to 
select which variables should be displayed by using the ":font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.V:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.ariables to 
Display&per.&per.&per." option under the :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.O:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.ptions menu pick&per.  The Variables window will be 
updated after each statement is executed during single step or animate modes&per.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.The :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.A:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.nimate button causes SblEdit to execute the program, and to automatically 
highlight each line of code before it is executed&per.  The speed of execution can 
be controlled by the ":font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.S:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.peed of Animated Run" option under the :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.O:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.ptions menu pick&per.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.The :font facename=default size=0x0.:font facename='Arial' size=10x6.:hp5.C:ehp5.:font facename=default size=0x0.:font facename='Arial' size=10x6.alls button controls the display of the Calls window&per.  It acts as a 
toggle, causing the window to appear and disappear&per.  The Calls window displays 
the call frame stack of the currently nested procedures&per.  The most 
deeply-nested procedure is listed at the top of the window&per.  If you click on a 
procedure with the mouse, SblEdit will switch the focus to the main display 
window, and highlight the next statement to be executed in the selected 
procedure&per.:font facename=default size=0x0.
:li.
:li.
:li.
:font facename='Arial' size=12x8.:hp2.Options:ehp2.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.The editor options are reasonably self-evident, and are not covered here&per.  :font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.The Compiler Option "Dump After Compile" causes SblEdit to create a text dump 
of the &per.SBX file after compilation of each program&per.  The text dump file will 
have an extension of &per.SBM&per.  This is mostly of interest when trouble-shooting 
compiler bugs, or when considering optimizations, and so will most likely be 
only of marginal interest&per.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.The other Compiler Options are documented above&per.:font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.You can use the Runtime Option "Modify Command$ &per.&per.&per." to specify the value which 
SBL will return when the Command$ function is called&per. Selecting  "Clear All 
Breakpoints" will clear all the breakpoints in the current module&per.  When "Print 
to sbledit&per.log" is checked, all print statements will print to file sbledit&per.log 
as well as to the status bar&per.  :font facename=default size=0x0.
:li.
:li.
:font facename='Arial' size=10x6.The other Runtime Options are documented above&per.:font facename=default size=0x0.
:li.
:esl.
:euserdoc.
