:userdoc.
:title.Softbridge (embeddable) BASIC Language
:h1.Welcome to SBL
:p.Bring the competitive advantages of a standard scripting language to
your products without having to design, develop, and maintain a proprietary
language on your own.  With the Softbridge BASIC Language (SBL), your
developers will be free to devote their energies to features unique to
your applications.  That's why Lotus, Software Publishing, Information
Resources, Attachmate, Indigo, and ISICAD are among the growing number
of companies who have licensed SBL for use in their products.  SBL is
shipping in a number of products already, including Indigo's Reportsmith,
XTree for Windows, and ISICAD's Cadvance.  Dozens of other products
which will include SBL are now under development.
:p.
:p.:hp2.Language Features&colon.:ehp2.
:p.
SBL is a complete implementation of BASIC, conforming to Visual BASIC,
designed for integration into Windows, OS/2, and Windows NT applications.
Implemented as a Dynamic Link Library, SBL's full-featured API lets it
become a seamless extension of any application.  SBL will enable your
end-users, VARs, and systems integrators to fully exploit your
application by using an industry standard language fully extended to keep
up with changing technology.  Language features that will increase your
application's value to your end-users include&colon.
:dl break=fit tsize=20.
:dt.:hp1.Visual BASIC compatibility&colon.:ehp1.
:dd.open up your app to the millions of developers who know BASIC.
:dt.:hp1.External DLL support&colon.:ehp1.
:dd.access to MAPI, ODBC, and your application-specific functions and commands.
:dt.:hp1.Access to application controls and objects&colon.:ehp1.
:dd.simple BASIC access to control your application's menus,dialog boxes, and data objects.
:dt.:hp1.OLE 2.0 support&colon.:ehp1.
:dd.enabling inter-application automation.
:edl.
:p.
:p.
:p.:hp2.Integration Features&colon.:ehp2.
:p.Through SBL's API, SBL will become an integral part of your application.  SBL provides a number of integration features for your developers.
:p.
:ul.
:li.SBL permits BASIC source code and executables to be embedded into application data structures (such as database fields or spread-sheet cells).
:li.SBL is ready for localization.  All text and messages are maintained in a resource file.  SBL fully exploits the international set of Windows string and character functions.
:li.SBL utilizes application-provided callback functions to control all aspects of SBL's execution, exception-handling, and I/O in an application-consistent fashion.  It also allows the application to selectively filter the information.
:li.SBL programs can display and access fields from any application dialog box, such as an application's FileOpen dialog box.
:li.Integrating C++ and OLE 2.0 objects is accomplished through a simple SBL API call.
:li.The SBL API defines a complete set of functions for constructing a sophisticated debugger.
:li.Sources to a BASIC editor and debugger that can be customized and integrated into your application are provided.
:li.SBL provides a complete BASIC .hlp file for integration with an application's help system.
:eul.
:p.
While SBL will look and act like a tailor-made part of your application,
integrating SBL is a straight-forward task.  Developers have found that
fully integrating SBL with their applications can take as little as three
developer-months.
:h1.Commands &amp. Datatypes
:p.The list below contains the commands, functions,
and data types that are part of the Softbridge BASIC Language (SBL).
:dl break=fit tsize=20.
:dt.:hp1.Arrays&colon.:ehp1.
:dd.Dim, Erase, Global, LBound, Option Base, ReDim, Static, UBound
:dt.:hp1.Controlling program flow&colon.:ehp1.
:dd.DoEvents, Do...Loop, End, For...Next, Goto, If...Then...Else, On...Error, Select Case, Stop, While...Wend
:dt.:hp1.Converting&colon.:ehp1.
:dd.Asc, CCur, CDbl, Chr, CInt, CLng, CSng, CStr, CVar, CVDate, DateSerial, DateValue, Day, Fix, Format, Hex, Hour, Int, Minute, Month, Oct, Second, Str, TimeSerial, TimeValue, Val, Weekday, Year
:dt.:hp1.Copying&colon.:ehp1.
:dd.Clear, GetData, GetFormat, GetText, SetData, SetText
:dt.:hp1.Date/Time&colon.:ehp1.
:dd.Date functions, Now, Time functions, Timer
:dt.:hp1.DDE&colon.:ehp1.
:dd.LinkExecute, LinkPoke, LinkRequest, LinkSend
:dt.:hp1.Dialog Box&colon.:ehp1.
:dd.Begin Dialog, Button, ButtonGroup, CancelButton,
Caption, CheckBox, ComboBox, Dialog, GetCurValue, GroupBox,
InputBox, ListBox, MsgBox Function, MsgBox Statement,
OKButton, Option Button, Option Group, Text, TextBox
:dt.:hp1.Error trapping&colon.:ehp1.
:dd.Error Function, Error Statement, Err Function, Err Statement, Erl, On Error, Resume
:dt.:hp1.File I/O&colon.:ehp1.
:dd.ChrDir, ChDrive, Close, CurDir,
Dir, EOF, FileAttr, FileCopy, FileDate, FileLen, FreeFile, Get, GetAttr, Input Function, Input Statement, Kill, Line Input, Loc, Lock...Unlock, LOF, MkDir, Name, Open, Print, Put, Reset, RmDir, Seek, SetAttr, Spc, Tab, Width, Write
:dt.:hp1.Math&colon.:ehp1.
:dd.Abs, Atn, Cos, Exp, Log, Randomize, Rnd, Sgn, Sin, Sqr, Tan
:dt.:hp1.Procedures&colon.:ehp1.
:dd.Call, Declare (includes calling DLL's and other SBL modules),  Exit, Exit Sub, Function...End Function, Sub...End Sub
:dt.:hp1.Strings&colon.:ehp1.
:dd.Asc, Chr, Format, Instr, Lcase, Left, Len, Let, LSet, LTrim, Mid Function, Mid Statement, Option Compare, Right, RTrim, RSet, Space, StrComp, Trim, Ucase
:dt.:hp1.Data Types, Constants &amp. Variables&colon.:ehp1.
:dd.Currency, Date/Time, Double, Integer, Long, Single, String (variable and fixed length), Type (records), Variant; Const, Dim, Global, Static; Def type, IsDate, IsEmpty, IsNull, IsNumeric, Var type, Option Explicit
:dt.:hp1.Miscellany&colon.:ehp1.
:dd.AppActivate, Assert, Beep, Command, Environ, GetField, Rem, SendKeys, SetField, Shell
:dt.:hp1.Compiler commands&colon.:ehp1.
:dd.$CStrings, $Include, $NoCStrings
:edl.
:p.SBL is an embeddable implementation of BASIC, conforming to Visual Basic 2.0 language syntax.  SBL is licensed to software developers for inclusion in their Windows, Windows NT, and OS/2 applications.
:h1.What's in the demo
:p.
Contained in this folder is the Softbridge BASIC Language (SBL) Technical
Evaluation/Demo Kit.  The purpose of this kit is to provide you with a
quick means of examining SBL's functionality.
:p.
:p.
The kit includes our SblEdit application, a simple BASIC program editor
and debugger.  It is not meant to illustrate the full functionality of SBL,
nor is the simple interface provided here intended to represent the type of
interface that can be used in your application.  SblEdit can be thought of as
a surrogate for your prospective application.  The kit also includes sample
files that demonstrate some of SBL's fundamental capabilities.  Although
it only reveals a limited number of SBL features, SblEdit, along with the
included sample files and help documentation, should provide a means to
understanding the capabilities of SBL.
:p.
:p.
Simply double click on the SblEdit icon in the SBL folder to run SblEdit.
Under the Help menu select SblEdit Help to see the SblEdit User Guide
that documents the use of the SBL text editor to edit, compile, and run
SBL scripts.
:p.
:p.
The kit also includes lists of SBL's language and integration features,
as well as a list of SBL commands and functions.
:h1.Contact Information
:p.
For more information about SBL, contact the Language Products Group at&colon.
:lm margin=20.
:lines.
Softbridge, Inc.
125 CambridgePark Drive
Cambridge, MA 02140

(617) 576-2257 (voice)
(617) 864-7747 (fax)
:elines.
:lm margin=1.
:euserdoc.
